//+------------------------------------------------------------------+
//|                                            Breakeven EA v1.2.mq4 |
//|                                        Copyright  2011, tigpips |
//|                                                tigpips@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, tigpips"
#property link      "tigpips@gmail.com"

extern int Break_Even_After_X_Pips = 690;
extern int XpipsAboveBE = 20;
//extern bool Show_Info = false;
//extern color Text_Color = Red;
//extern int font_size = 9;
//extern int font_gap_distance = 12;
extern bool useMagicNumber = false;
extern int Magic = 1234567;


int init()
{
   DeleteAllObjects();
   if(Digits == 5)
   {
      Break_Even_After_X_Pips = Break_Even_After_X_Pips * 10;
      XpipsAboveBE = XpipsAboveBE * 10;
   }

   return(0);
}

int deinit()
{
   DeleteAllObjects();
   return(0);
}

int start()
{
   DeleteAllObjects();
   AdjustStopLoss();
   return(0);
}
//+------------------------------------------------------------------+

void AdjustStopLoss()
{
   string commentstr1, commentstr2, commentstr3, commentstr4;
   if(Digits == 5)
   {
      commentstr1 = "Break Even After X Pips : "+Break_Even_After_X_Pips/10;
      commentstr2 = "X pips Above BE : "+XpipsAboveBE/10;
   }
   else if(Digits == 4)
   {
      commentstr1 = "Break Even After X Pips : "+Break_Even_After_X_Pips;
      commentstr2 = "\nX pips Above BE : "+XpipsAboveBE;   
   }
   for(int cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(useMagicNumber == true)
      {
         if(OrderMagicNumber()==Magic && OrderStopLoss() != OrderOpenPrice())
         {
            if(Digits == 5)
            {
               commentstr3="#"+OrderTicket()+" "+OrderSymbol()+" "+FindOpType(OrderType())+" Pips : "+DoubleToStr(( OrderProfit() - OrderCommission() ) / OrderLots() / MarketInfo( OrderSymbol(), MODE_TICKVALUE )/10,1);         
            }
            else if(Digits == 4)
            {
               commentstr4="#"+OrderTicket()+" "+OrderSymbol()+" "+FindOpType(OrderType())+" Pips : "+DoubleToStr(( OrderProfit() - OrderCommission() ) / OrderLots() / MarketInfo( OrderSymbol(), MODE_TICKVALUE ),1);         
            }
            if(( OrderProfit() - OrderCommission() ) / OrderLots() / MarketInfo( OrderSymbol(), MODE_TICKVALUE ) >= Break_Even_After_X_Pips)
            {
               if(OrderType()==OP_SELL){
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(XpipsAboveBE*Point),OrderTakeProfit(),0,Red);
               }
               if(OrderType()==OP_BUY){
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(XpipsAboveBE*Point),OrderTakeProfit(),0,Blue);
               }  
            }        
         }
      }
      else if(useMagicNumber == false)
      {
         if(OrderStopLoss() != OrderOpenPrice())
         {
            if(Digits == 5)
            {
               commentstr3="#"+OrderTicket()+" "+OrderSymbol()+" "+FindOpType(OrderType())+" Pips : "+DoubleToStr(( OrderProfit() - OrderCommission() ) / OrderLots() / MarketInfo( OrderSymbol(), MODE_TICKVALUE )/10,1);         
            }
            else if(Digits == 4)
            {
               commentstr4="#"+OrderTicket()+" "+OrderSymbol()+" "+FindOpType(OrderType())+" Pips : "+DoubleToStr(( OrderProfit() - OrderCommission() ) / OrderLots() / MarketInfo( OrderSymbol(), MODE_TICKVALUE ),1);         
            }
            if(( OrderProfit() - OrderCommission() ) / OrderLots() / MarketInfo( OrderSymbol(), MODE_TICKVALUE ) >= Break_Even_After_X_Pips)
            {
               if(OrderType()==OP_SELL){
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(XpipsAboveBE*Point),OrderTakeProfit(),0,Red);
               }
               if(OrderType()==OP_BUY){
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(XpipsAboveBE*Point),OrderTakeProfit(),0,Blue);
               }  
            }                       
         }
      }
   }
/*   if(Show_Info==true)
   {
      ObjectCreate("ltext_1",OBJ_LABEL,0,0,0,0,0);
      ObjectSet("ltext_1",OBJPROP_CORNER,1);
      ObjectSet("ltext_1",OBJPROP_XDISTANCE,20);
      ObjectSet("ltext_1",OBJPROP_YDISTANCE,20);
      ObjectSetText("ltext_1",commentstr1,font_size,"Tahoma",Text_Color);
      
      ObjectCreate("ltext_2",OBJ_LABEL,0,0,0,0,0);
      ObjectSet("ltext_2",OBJPROP_CORNER,1);
      ObjectSet("ltext_2",OBJPROP_XDISTANCE,20);
      ObjectSet("ltext_2",OBJPROP_YDISTANCE,20+font_gap_distance);
      ObjectSetText("ltext_2",commentstr2,font_size,"Tahoma",Text_Color);
      
      ObjectCreate("ltext_3",OBJ_LABEL,0,0,0,0,0);
      ObjectSet("ltext_3",OBJPROP_CORNER,1);
      ObjectSet("ltext_3",OBJPROP_XDISTANCE,20);
      ObjectSet("ltext_3",OBJPROP_YDISTANCE,20+(font_gap_distance*2));
      ObjectSetText("ltext_3",commentstr3,font_size,"Tahoma",Text_Color);
      
      ObjectCreate("ltext_4",OBJ_LABEL,0,0,0,0,0);
      ObjectSet("ltext_4",OBJPROP_CORNER,1);
      ObjectSet("ltext_4",OBJPROP_XDISTANCE,20);
      ObjectSet("ltext_4",OBJPROP_YDISTANCE,20+(font_gap_distance*3));
      ObjectSetText("ltext_4",commentstr4,font_size,"Tahoma",Text_Color);      
   }
   else
   {
      DeleteAllObjects();
   }
*/
}

string FindOpType(int k)
{
   if(k == 1)
   {
      return("SELL");
   }
   else if (k == 0)
   {
      return("BUY");  
   }  
   return("");
}

void DeleteAllObjects()
{
   int objs = ObjectsTotal();
   string name;
   for(int cnt=ObjectsTotal()-1;cnt>=0;cnt--)
   {
      name=ObjectName(cnt);
      if (StringFind(name,"ltext_",0)>-1) ObjectDelete(name);
      WindowRedraw();
   }
}